import java.awt.*;
import javax.swing.*;
import jfd.ale.*;
import java.lang.reflect.Field;

public class AdvancedJFC1 extends JFrame implements FieldToComponentMapper
{
   // Top section components

   private JButton logo            = null;
   private JButton display         = null;
   private JButton bitControl      = null;
   private JButton algorithms      = null;
   private JButton root            = null;
   private JButton windows         = null;
   private JButton imageSize       = null;

   // Middle section components

   private JScrollPane messageArea = null;
   private JButton next            = null;
   private JButton prev            = null;
   private JButton load            = null;
   private JButton save            = null;
   private JButton print           = null;
   private JButton delete          = null;
   private JButton files           = null;

   // Bottom row of buttons

   private JButton xvPad           = null;
   private JButton xvPrompt        = null;
   private JButton crop            = null;
   private JButton uncrop          = null;
   private JButton autocrop        = null;
   private JButton aboutXV         = null;
   private JButton quit            = null;

   // Next to bottom row of buttons

   private JButton buttonOne       = null;
   private JButton buttonTwo       = null;
   private JButton buttonThree     = null;
   private JButton buttonFour      = null;
   private JButton smaller         = null;
   private JButton bigger          = null;
   private JButton rotateLeft      = null;
   private JButton rotateRight     = null;
   private JButton hMirror         = null;
   private JButton vMirror         = null;
   private JButton grab            = null;

   // Status line

   private JButton status          = null;

   public AdvancedJFC1() throws Exception
   {
      addWindowListener(new AppCloser());

      doTopSection();
      doMiddleSection();
      doBottomButtonRow();
      doNextToBottomButtonRow();
      doStatusLine();

      ALE.brew(
         "advancedjfc1.ale", "main", this, getContentPane()
      );

      setSize(510, 420);
      setVisible(true);
   }

   private static String gifName(String name)
   {
      return(
         "gifs" + java.io.File.separator + "xv" +
         java.io.File.separator + name + ".gif"
      );
   }

   private void doTopSection()
   {
      logo       = new JButton(new ImageIcon(gifName("unregistered")));

      display    = new JButton("Display");
      bitControl = new JButton("24/8 Bit");
      algorithms = new JButton("Algorithms");

      root       = new JButton("Root");
      windows    = new JButton("Windows");
      imageSize  = new JButton("ImageSize");
   }

   private void doMiddleSection()
   {
      messageArea = new JScrollPane(new JTextArea());
      next        = new JButton("Next");
      prev        = new JButton("Prev");
      load        = new JButton("Load");
      save        = new JButton("Save");
      print       = new JButton("Print");
      delete      = new JButton("Delete");
      files       = new JButton("0 files");
   }

   private void doBottomButtonRow()
   {
      xvPad    = new JButton(new ImageIcon(gifName("xvPad")));
      xvPrompt = new JButton(new ImageIcon(gifName("xvPrompt")));

      crop     = new JButton("Crop");
      uncrop   = new JButton("UnCrop");
      autocrop = new JButton("AutoCrop");
      aboutXV  = new JButton("About XV");
      quit     = new JButton("Quit");
   }

   private void doNextToBottomButtonRow()
   {
      buttonOne   = new JButton(new ImageIcon(gifName("buttonOne")));
      buttonTwo   = new JButton(new ImageIcon(gifName("buttonTwo")));
      buttonThree = new JButton(new ImageIcon(gifName("buttonThree")));
      buttonFour  = new JButton(new ImageIcon(gifName("buttonFour")));
      smaller     = new JButton(new ImageIcon(gifName("smaller")));
      bigger      = new JButton(new ImageIcon(gifName("bigger")));
      rotateLeft  = new JButton(new ImageIcon(gifName("rotateLeft")));
      rotateRight = new JButton(new ImageIcon(gifName("rotateRight")));
      hMirror     = new JButton(new ImageIcon(gifName("hMirror")));
      vMirror     = new JButton(new ImageIcon(gifName("vMirror")));
      grab        = new JButton("Grab");
   }

   private void doStatusLine()
   {
      status = new JButton(
         "440x270 image., 8-bit mode. Got all 200 colors. (199 unique)"
      );
   }

   public Component mapToComponent(Field f)
      throws Exception
   {
      return((Component)f.get(this));
   }

   public static void main(String args[]) throws Exception
   {
      new AdvancedJFC1();
   }
}
