package jfd.ale;
import java.util.Hashtable;

class Align
{
   public static final String LEFT   = "L";
   public static final String CENTER = "C";
   public static final String RIGHT  = "R";
   public static final String TOP    = "T";
   public static final String BOTTOM = "B";
   private static Hashtable table    = new Hashtable();
   private String s = null;

   private Align(String s)
   {
      this.s = s;
   }

   public String toString()
   {
      return(s);
   }

   public String getHorizAlign()
   {
      if(this == LT || this == LC || this == LB)
         return(LEFT);

      if(this == CT || this == CC || this == CB)
         return(CENTER);

      return(RIGHT);
   }

   public String getVertAlign()
   {
      if(this == LT || this == CT || this == RT)
         return(TOP);

      if(this == LC || this == CC || this == RC)
         return(CENTER);

      return(BOTTOM);
   }

   public static Align LT      = new Align("LT");
   public static Align LC      = new Align("LC");
   public static Align LB      = new Align("LB");
   public static Align CT      = new Align("CT");
   public static Align CC      = new Align("CC");
   public static Align CB      = new Align("CB");
   public static Align RT      = new Align("RT");
   public static Align RC      = new Align("RC");
   public static Align RB      = new Align("RB");
   public static Align DEFAULT = CC;

   static
   {
      table.put(LT.toString(), LT);
      table.put(LC.toString(), LC);
      table.put(LB.toString(), LB);
      table.put(CT.toString(), CT);
      table.put(CC.toString(), CC);
      table.put(CB.toString(), CB);
      table.put(RT.toString(), RT);
      table.put(RC.toString(), RC);
      table.put(RB.toString(), RB);
   }

   public static Align fromString(String s)
   {
      return((Align)table.get(s));
   }
}
