package jfd.ale;

import java.lang.reflect.Method;
import java.util.Hashtable;

class ExternalMethodVisitor extends Visitor
{
   private Class theClass               = null;
   private Hashtable methodNameToMethod = null;

   public ExternalMethodVisitor(
      Object externalObject, Hashtable methodNameToMethod
   )
   {
      theClass                = externalObject.getClass();
      this.methodNameToMethod = methodNameToMethod;
   }

   public void visited(ExternalMethodNode externalMethodNode)
   {
      Method m    = null;
      String name = externalMethodNode.getName();

      if((m = (Method)methodNameToMethod.get(name)) == null)
      {
         try
         {
            m = theClass.getMethod(
               name,
               new Class[] {}
            );
         }
         catch(Exception e)
         {
            System.out.println(
               "No accessible method with signature \"" +
               name + "()" + "\" found for " + theClass
            );

            System.exit(-1);
         }

         if(m.getReturnType() != double.class)
         {
            System.out.println(
               "Return type of \"" +
               name + "()" + "\" must be \"double\" in " + theClass
            );

            System.exit(-1);
         }

         methodNameToMethod.put(name, m);
      }
   }
}
