package jfd.ale;

import java.util.Hashtable;

class MethodNode extends Node
{
   private String target = null;
   private String name   = null;

   public MethodNode(String target, String name)
   {
      this.target = target;
      this.name   = name;
   }

   public String getTarget()
   {
      return(target);
   }

   public String getName()
   {
      return(name);
   }

   public void accept(Visitor v)
   {
      v.visited(this);
   }

   public String toString()
   {
      return(target + "." + name);
   }

   public double execute(
      ConstraintLayout layout
   )
   {
      return(layout.invoke(target, name));
   }
}
