/* Generated By:JavaCC: Do not edit this line. Parser.java */
package jfd.ale;

import java.io.Reader;
import java.io.StringReader;
import java.io.InputStreamReader;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.File;
import java.net.URL;
import java.util.Hashtable;

class Parser implements ParserConstants {
   private static Hashtable arrayToSectionTable    = new Hashtable();
   private static Hashtable fileNameToSectionTable = new Hashtable();

   public static Section getSection(
      String array[],
      String sectionName
   )
      throws Exception
   {
      Hashtable sectionNameToSection =
         (Hashtable)arrayToSectionTable.get(array);

      if(sectionNameToSection == null)
      {
         StringBuffer sb = new StringBuffer("");

         for(int i = 0; i < array.length; i ++)
            sb.append((i > 0 ? "\n" : "") + array[i]);

         Parser p = new Parser(new StringReader(sb.toString()));

         sectionNameToSection = p.input();
         arrayToSectionTable.put(array, sectionNameToSection);
      }

      Section theSection =
         (Section)sectionNameToSection.get(sectionName);

      if(theSection == null)
      {
         throw new Exception(
            "No section called \"" + sectionName + "\" found"
         );
      }

      return(theSection);
   }

   private static InputStream getInputStream(String fileName) throws Exception
   {
      // fileName could be:
      //    (a) an absolute path to a file
      //    (b) a non-absolute to a file
      //    (c) a url
      //
      // Determine which of these we are dealing with

      String HTTP    = "http:";
      String FILE    = "file:";
      InputStream in = null;

      if(fileName.regionMatches(true, 0, HTTP, 0, HTTP.length()) ||
         fileName.regionMatches(true, 0, FILE, 0, FILE.length()))
      {
         URL u = new URL(fileName);
         in    = u.openStream();
      }
      else
      {
         File f = new File(fileName);

         if(f.isAbsolute())
            in = new FileInputStream(fileName);
         else
            in = ClassLoader.getSystemResourceAsStream(fileName);
      }

      return(in);
   }

   public static Section getSection(
      String fileName,
      String sectionName
   )
      throws Exception
   {
      Hashtable sectionNameToSection =
         (Hashtable)fileNameToSectionTable.get(fileName);

      if(sectionNameToSection == null)
      {
         // This could be an absolute path, a file name or a URL
         // If this is an absolute path we'll read it as an actual file
         // otherwise read it as a system resource

         InputStream in = null;
         File f         = new File(fileName);

         try
         {
            if((in = getInputStream(fileName)) == null)
            {
               throw new Exception(
                  "Unable to locate: \"" + fileName + "\""
               );
            }

            Reader reader        = new InputStreamReader(in);
            Parser p             = new Parser(reader);
            sectionNameToSection = p.input();
         }
         catch(Exception e)
         {
            throw(e);
         }
         finally
         {
            if(in != null)
            {
               try { in.close(); } catch(Exception ignored) {}
            }
         }

         fileNameToSectionTable.put(fileName, sectionNameToSection);
      }

      Section theSection =
         (Section)sectionNameToSection.get(sectionName);

      if(theSection == null)
      {
         throw new Exception(
            "No section called \"" + sectionName +
            "\" found in file/resource \"" + fileName + "\""
         );
      }

      return(theSection);
   }

   public static NodePair parseNodePair(String s)
      throws Exception
   {
      Parser p = new Parser(new StringReader(s));
      return(p.nodePair(null));
   }

   private static int parseInt(String s)
   {
      int value = 0;

      try
      {
         value = Integer.parseInt(s);
      }
      catch(NumberFormatException e)
      {
         // We'll only ever call this method when our <INTEGER>
         // token has been matched so we'll never actually
         // get a NumberFormatException
      }

      return(value);
   }

   private static double parseReal(String s)
   {
      double value = 0.0;

      try
      {
         Double d = new Double(s);
         value    = d.doubleValue();
      }
      catch(NumberFormatException e)
      {
         // We'll only ever call this method when our <REAL>
         // or <INTEGER> token has been matched so we'll never actually
         // get a NumberFormatException
      }

      return(value);
   }

  final public Hashtable input() throws ParseException {
   Hashtable sectionNameToSection = new Hashtable();
   Hashtable defineTable          = new Hashtable();
   String name                    = null;
   Section section                = null;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SECTION:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      jj_consume_token(SECTION);
      jj_consume_token(ID);
         name = token.image;
      jj_consume_token(26);
            section = new Section(name);
            sectionNameToSection.put(name, section);
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DEFINE:
          ;
          break;
        default:
          jj_la1[1] = jj_gen;
          break label_2;
        }
        defineTable = define(section);
      }
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FLOW:
        case GRID:
        case ID:
          ;
          break;
        default:
          jj_la1[2] = jj_gen;
          break label_3;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ID:
          constraints(defineTable, section);
          break;
        case FLOW:
          flow(defineTable,        section);
          break;
        case GRID:
          grid(defineTable,        section);
          break;
        default:
          jj_la1[3] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(27);
    }
    jj_consume_token(0);
      {if (true) return(sectionNameToSection);}
    throw new Error("Missing return statement in function");
  }

  final public void constraints(Hashtable defineTable, ConstraintsContainer constraintsContainer) throws ParseException {
   Constraints constraints = null;
   String name             = null;
   Node x                  = null;
   Node y                  = null;
   Node w                  = null;
   Node h                  = null;
   Align align             = null;
   NodePair pair           = null;
    jj_consume_token(ID);
      name = token.image;
    jj_consume_token(28);
    if (jj_2_1(2)) {
      w = sum(defineTable);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case P:
        jj_consume_token(P);
                                      w = new ConstantNode(0.0);
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(29);
    if (jj_2_2(2)) {
      h = sum(defineTable);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case P:
        jj_consume_token(P);
                                      h = new ConstantNode(0.0);
        break;
      default:
        jj_la1[5] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(29);
    pair = nodePair(defineTable);
        x = pair.getFirst(); y = pair.getSecond();
    jj_consume_token(29);
    jj_consume_token(ALIGN);
                align = Align.fromString(token.image);
    jj_consume_token(30);
      constraintsContainer.addConstraints(
         new Constraints(
            name, w, h, x, y, align
         )
      );
  }

  final public void flow(Hashtable defineTable, ConstraintsContainer constraintsContainer) throws ParseException {
   FlowResource flowResource   = null;
   FlowDirection flowDirection = null;
   Node start                  = null;
   Node end                    = null;
   Node coordinate             = null;
   NodePair pair               = null;
    jj_consume_token(FLOW);
    jj_consume_token(28);
    jj_consume_token(FLOW_DIRECTION);
         flowDirection = FlowDirection.fromString(token.image);
    jj_consume_token(29);
    pair = nodePair(defineTable);
        start = pair.getFirst(); end = pair.getSecond();
    jj_consume_token(29);
    coordinate = sum(defineTable);
         flowResource =
            new FlowResource(flowDirection, start, end, coordinate);
    jj_consume_token(30);
    jj_consume_token(26);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_4;
      }
      constraints(defineTable, flowResource);
    }
    jj_consume_token(27);
      Constraints array[] = flowResource.getConstraints();

      for(int i = 0; i < array.length; i ++)
         constraintsContainer.addConstraints(array[i]);
  }

  final public void grid(Hashtable defineTable, ConstraintsContainer constraintsContainer) throws ParseException {
   GridResource gridResource = null;
   int rows                  = 0;
   int columns               = 0;
   Node xMin                 = null;
   Node yMin                 = null;
   Node xMax                 = null;
   Node yMax                 = null;
   NodePair pair             = null;
    jj_consume_token(GRID);
    jj_consume_token(28);
    jj_consume_token(INTEGER);
                  rows    = parseInt(token.image);
    jj_consume_token(29);
    jj_consume_token(INTEGER);
                  columns = parseInt(token.image);
    jj_consume_token(29);
    pair = nodePair(defineTable);
         xMin = pair.getFirst();
         yMin = pair.getSecond();
    jj_consume_token(29);
    pair = nodePair(defineTable);
         xMax = pair.getFirst();
         yMax = pair.getSecond();

         gridResource = new GridResource(
            rows, columns, xMin, yMin, xMax, yMax
         );
    jj_consume_token(30);
    jj_consume_token(26);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_5;
      }
      constraints(defineTable, gridResource);
    }
    jj_consume_token(27);
      Constraints array[] = gridResource.getConstraints();

      for(int i = 0; i < array.length; i ++)
         constraintsContainer.addConstraints(array[i]);
  }

  final public Hashtable define(Section section) throws ParseException {
   String s = null;
   Node n   = null;
   Hashtable defineTable = new Hashtable();
    jj_consume_token(DEFINE);
    jj_consume_token(26);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_6;
      }
      jj_consume_token(ID);
                                s = token.image;
      jj_consume_token(31);
      n = sum(defineTable);
                                defineTable.put(s, n);
      jj_consume_token(32);
    }
    jj_consume_token(27);
      {if (true) return(defineTable);}
    throw new Error("Missing return statement in function");
  }

  final public NodePair nodePair(Hashtable defineTable) throws ParseException {
   Node first  = null;
   Node second = null;
    first = sum(defineTable);
    jj_consume_token(29);
    second = sum(defineTable);
      {if (true) return(new NodePair(first, second));}
    throw new Error("Missing return statement in function");
  }

  final public Node sum(Hashtable defineTable) throws ParseException {
   Token which   = null;
   Node left     = null;
   Node right    = null;
   char operator = '\0';
    left = term(defineTable);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_7;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        which = jj_consume_token(PLUS);
        break;
      case MINUS:
        which = jj_consume_token(MINUS);
        break;
      default:
        jj_la1[10] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      right = term(defineTable);
         operator = (which.kind == PLUS ? '+' : '-');
         left     = new BinaryNode(left, operator, right);
    }
      {if (true) return(left);}
    throw new Error("Missing return statement in function");
  }

  final public Node term(Hashtable defineTable) throws ParseException {
   Token which   = null;
   Node left     = null;
   Node right    = null;
   char operator = '\0';
    left = unary(defineTable);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MULTIPLY:
      case DIVIDE:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_8;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MULTIPLY:
        which = jj_consume_token(MULTIPLY);
        break;
      case DIVIDE:
        which = jj_consume_token(DIVIDE);
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      right = unary(defineTable);
         operator = (which.kind == MULTIPLY ? '*' : '/');
         left     = new BinaryNode(left, operator, right);
    }
      {if (true) return(left);}
    throw new Error("Missing return statement in function");
  }

  final public Node unary(Hashtable defineTable) throws ParseException {
   Node n          = null;
   boolean isUnary = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MINUS:
      jj_consume_token(MINUS);
         isUnary = true;
      n = element(defineTable);
      break;
    case INTEGER:
    case REAL:
    case ATTRIBUTE:
    case ID:
    case 28:
    case 34:
      n = element(defineTable);
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return(isUnary ? new UnaryNode(n) : n);}
    throw new Error("Missing return statement in function");
  }

  final public Node element(Hashtable defineTable) throws ParseException {
   Node n = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case REAL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REAL:
        jj_consume_token(REAL);
        break;
      case INTEGER:
        jj_consume_token(INTEGER);
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
         n = new ConstantNode(parseReal(token.image));
      break;
    case ATTRIBUTE:
    case ID:
    case 34:
      n = invocation(defineTable);
      break;
    case 28:
      jj_consume_token(28);
      n = sum(defineTable);
      jj_consume_token(30);
      break;
    default:
      jj_la1[15] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return(n);}
    throw new Error("Missing return statement in function");
  }

  final public Node invocation(Hashtable defineTable) throws ParseException {
   String id            = null;
   String attributeName = null;
   int line             = 0;
    if (jj_2_3(2)) {
      jj_consume_token(ID);
                id = token.image;
      jj_consume_token(28);
      jj_consume_token(30);
                {if (true) return(new ExternalMethodNode(id));}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
        jj_consume_token(ID);
                id = token.image;
        jj_consume_token(33);
        attributeName = attribute();
         {if (true) return(new MethodNode(id, attributeName));}
        break;
      case ATTRIBUTE:
        attributeName = attribute();
         {if (true) return(new MethodNode("parent", attributeName));}
        break;
      case 34:
        jj_consume_token(34);
            line = token.beginLine;
        jj_consume_token(ID);
         Node n = (Node)defineTable.get(token.image);

         if(n == null)
         {
            System.out.println(
               "Reference to undefined variable: \"$" + token.image +
               "\", line: " + line
            );

            System.exit(-1);
         }

         {if (true) return(n);}
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public String attribute() throws ParseException {
    jj_consume_token(ATTRIBUTE);
      {if (true) return(token.image.toLowerCase());}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  final private boolean jj_3R_14() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_3R_16()) return true;
    return false;
  }

  final private boolean jj_3R_9() {
    if (jj_3R_10()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_11()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(ID)) return true;
    if (jj_scan_token(33)) return true;
    return false;
  }

  final private boolean jj_3R_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_14()) {
    jj_scanpos = xsp;
    if (jj_3R_15()) return true;
    }
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_9()) return true;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(ID)) return true;
    if (jj_scan_token(28)) return true;
    return false;
  }

  final private boolean jj_3R_20() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3R_21()) {
    jj_scanpos = xsp;
    if (jj_3R_22()) {
    jj_scanpos = xsp;
    if (jj_3R_23()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_9()) return true;
    return false;
  }

  final private boolean jj_3R_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(10)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) return true;
    }
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_scan_token(28)) return true;
    if (jj_3R_9()) return true;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_3R_20()) return true;
    return false;
  }

  final private boolean jj_3R_10() {
    if (jj_3R_12()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_13()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_17() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) return true;
    }
    return false;
  }

  final private boolean jj_3R_16() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_17()) {
    jj_scanpos = xsp;
    if (jj_3R_18()) {
    jj_scanpos = xsp;
    if (jj_3R_19()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_scan_token(34)) return true;
    if (jj_scan_token(ID)) return true;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_3R_24()) return true;
    return false;
  }

  final private boolean jj_3R_15() {
    if (jj_3R_16()) return true;
    return false;
  }

  final private boolean jj_3R_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(8)) {
    jj_scanpos = xsp;
    if (jj_scan_token(9)) return true;
    }
    return false;
  }

  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[17];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x80000,0x100000,0x1060000,0x1060000,0x10000,0x10000,0x1000000,0x1000000,0x1000000,0x300,0x300,0xc00,0xc00,0x11803200,0x3000,0x11803000,0x1800000,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4,0x0,0x4,0x4,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[3];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public Parser(java.io.InputStream stream) {
     this(stream, null);
  }
  public Parser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[35];
    for (int i = 0; i < 35; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 17; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 35; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 3; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
